/*
 * QQQ - Low-code Application Framework for Engineers.
 * Copyright (C) 2021-2022.  Kingsrook, LLC
 * 651 N Broad St Ste 205 # 6917 | Middletown DE 19709 | United States
 * contact@kingsrook.com
 * https://github.com/Kingsrook/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package com.kingsrook.sampleapp.dashboard.widgets;


import com.kingsrook.qqq.backend.core.actions.dashboard.RenderWidgetAction;
import com.kingsrook.qqq.backend.core.context.QContext;
import com.kingsrook.qqq.backend.core.exceptions.QException;
import com.kingsrook.qqq.backend.core.model.actions.widgets.RenderWidgetInput;
import com.kingsrook.qqq.backend.core.model.actions.widgets.RenderWidgetOutput;
import com.kingsrook.qqq.backend.core.model.metadata.QInstance;
import com.kingsrook.qqq.backend.core.model.metadata.dashboard.QWidgetMetaDataInterface;
import com.kingsrook.qqq.backend.core.model.metadata.dashboard.QuickSightChartMetaData;
import com.kingsrook.qqq.backend.core.model.session.QSession;
import com.kingsrook.sampleapp.metadata.SampleMetaDataProvider;
import org.junit.jupiter.api.Test;


/*******************************************************************************
 ** Unit test for PersonsByCreateDateBarChart
 *******************************************************************************/
class RenderAllWidgetsTest
{

   /*******************************************************************************
    **
    *******************************************************************************/
   @Test
   void test() throws QException
   {
      QInstance qInstance = SampleMetaDataProvider.defineInstance();
      QContext.init(qInstance, new QSession());

      ////////////////////////////////////////////////////////////////
      // make sure no widgets throw - and we get some code coverage //
      ////////////////////////////////////////////////////////////////
      for(QWidgetMetaDataInterface widget : qInstance.getWidgets().values())
      {
         if(widget instanceof QuickSightChartMetaData)
         {
            ///////////////////////////////////////////
            // credentials not in circleci, so, skip //
            ///////////////////////////////////////////
            continue;
         }

         RenderWidgetInput input = new RenderWidgetInput();
         input.setWidgetMetaData(widget);
         RenderWidgetOutput output = new RenderWidgetAction().execute(input);
      }
   }

}
